﻿/**
 * Copyright (c) 2003-2014, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.md or http://ckeditor.com/license
 */

/**************************************
    File modified for:
    WEButler V3.6 - www.webutler.de
    Copyright (c) 2008 - 2024
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

CKEDITOR.plugins.add( 'sourcedialog', {
	lang: [CKEDITOR.lang.detect(CKEDITOR.config.language)],
	icons: 'sourcedialog,sourcedialog-rtl',
	hidpi: true,

	init: function( editor ) {
		// Register the "source" command, which simply opens the "source" dialog.
		editor.addCommand( 'sourcedialog', new CKEDITOR.dialogCommand( 'sourcedialog' ) );

		// Register the "source" dialog.
		CKEDITOR.dialog.add( 'sourcedialog', this.path + 'dialogs/sourcedialog.js' );

		// If the toolbar is available, create the "Source" button.
		if ( editor.ui.addButton ) {
			editor.ui.addButton( 'Sourcedialog', {
				label: editor.lang.sourcedialog.toolbar,
				command: 'sourcedialog',
				toolbar: 'mode,10'
			} );
		}
		
		CKEDITOR.scriptLoader.load( 'admin/codemirror/editor/js/codemirror.js' );
		CKEDITOR.scriptLoader.load( 'admin/codemirror/lang/' + CKEDITOR.lang.detect(CKEDITOR.config.language) + '.js' );
		CKEDITOR.document.appendStyleSheet( 'admin/codemirror/config/editor.css' );
		CKEDITOR.scriptLoader.load( 'admin/codemirror/codemirror_config.js' );
	}
} );
